#include <QtGui>
#include "Makros.h"

class Widget : public QWidget
{
public:
    QMap<QString,void (*)(void *object,char *name, void *event)> map;


    Widget(QWidget *parent, Qt::WindowFlags flags) : QWidget(parent, flags) {}

    META_MAKRO2(QWidget,Widget);

};



extern "C" {


/*__declspec( dllexport ) void * __cdecl QWidget_Constructor(void *parent, int flags)
{
    return (QWidget*)(new Widget((QWidget*)parent,(Qt::WindowFlags)flags));
}







__declspec( dllexport ) void QWidget_Destructor(void *object)
{
    delete ((QWidget*)object);
}
*/




META_MAKRO(QWidget,Widget);








__declspec( dllexport ) void QWidget_Show(void *object)
{
    ((QWidget*)object)->show();
}





__declspec( dllexport ) void QWidget_Move(void *object, int x, int y)
{
    ((QWidget*)object)->move(x,y);
}





__declspec( dllexport ) void QWidget_Resize(void *object, int cx, int cy)
{
    ((QWidget*)object)->resize(cx,cy);
}




__declspec( dllexport ) void QWidget_activateWindow(void *object)
{
    ((QWidget*)object)->activateWindow();
}



__declspec( dllexport ) void QWidget_setContentMargins(void *object,int l, int t, int r, int b)
{
    ((QWidget*)object)->setContentsMargins(l,t,r,b);
}



__declspec( dllexport ) void QWidget_setAcceptDrops(void *object, int b)
{
    if (b == -1)
    {
        ((QWidget*)object)->setAcceptDrops(true);
    } else
    {
        ((QWidget*)object)->setAcceptDrops(false);
    }
}



__declspec( dllexport ) void QWidget_setMouseTracking(void *object, int b)
{
    if (b == -1)
    {
        ((QWidget*)object)->setMouseTracking(true);
    } else
    {
        ((QWidget*)object)->setMouseTracking(false);
    }
}


__declspec( dllexport ) void QWidget_setWindowOpacity(void *object, double o)
{
    ((QWidget*)object)->setWindowOpacity(o);
}



__declspec( dllexport ) void QWidget_setToolTip(void *object, char *text)
{
    ((QWidget*)object)->setToolTip(text);
}










__declspec( dllexport ) void QWidget_Close(void *object)
{
    ((QWidget*)object)->close();
}






__declspec( dllexport ) void QWidget_Hide(void *object)
{
    ((QWidget*)object)->hide();
}






__declspec( dllexport ) void QWidget_setEnabled(void *object, int b)
{
    if (b == -1)
    {
        ((QWidget*)object)->setEnabled(true);
    } else
    {
        ((QWidget*)object)->setEnabled(false);
    }
}




struct rect
{
    int array[sizeof(QRect)];
};

struct string
{
    int array[sizeof(QString)/4];
};





__declspec( dllexport ) void *QWidget_Constructor  (void * parent, int f )
{
    Widget *p = new Widget((QWidget*)parent,(Qt::WindowFlags)f);
    return p;
}

__declspec( dllexport ) void QWidget_Destructor (void *object)
{
    delete (QWidget*)object;
}

int QWidget_acceptDrops (void *object)
{
    return ((QWidget*)object)->acceptDrops();
}

int QWidget_accessibleDescription (void *object)
{
    QString s = ((QWidget*)object)->accessibleDescription();
    int i;

    memcpy(&i,&s,4);
    return i;
}

int QWidget_accessibleName (void *object)
{
    QString s = ((QWidget*)object)->accessibleName();
    int i;

    memcpy(&i,&s,4);
    return i;
}

int QWidget_actions (void *object)
{
    QList<QAction*> s;
    int *i;
    s = (((QWidget*)object)->actions());

    void *p = &s;
    i = (int*)p;
    return *i;
}

void activateWindow (void *object)
{
    ((QWidget*)object)->activateWindow();
}

void addAction (void *object, void * action )
{
    ((QWidget*)object)->addAction((QAction*)action);
}

void addActions (void *object, QList<QAction *> actions )
{

}

void adjustSize (void *object)
{
    ((QWidget*)object)->activateWindow();
}

int autoFillBackground (void *object)
{
    return ((QWidget*)object)->autoFillBackground();
}

QPalette::ColorRole backgroundRole (void *object);
QSize baseSize (void *object);
void * childAt (void *object, int x, int y )
{
    return ((QWidget*)object)->childAt(x,y);
}

void * childAt_2 (void *object, const QPoint & p );
rect childrenRect (void *object)
{
    QRect s;
    rect *i;
    s = (((QWidget*)object)->childrenRect());

    void *p = &s;
    i = (rect*)p;
    return *i;
}

QRegion childrenRegion (void *object);
void clearFocus (void *object);
void clearMask (void *object);
QMargins contentsMargins (void *object);
QRect contentsRect (void *object);
Qt::ContextMenuPolicy contextMenuPolicy (void *object);
QCursor cursor (void *object);
WId effectiveWinId (void *object);
void ensurePolished (void *object);
Qt::FocusPolicy focusPolicy (void *object);
void * focusProxy (void *object);
void * focusWidget (void *object);
const QFont & font (void *object);
QFontInfo fontInfo (void *object);
QFontMetrics fontMetrics (void *object);
QPalette::ColorRole foregroundRole (void *object);
QRect frameGeometry (void *object);
QSize frameSize (void *object);
const QRect & geometry (void *object);
void getContentsMargins (void *object, int * left, int * top, int * right, int * bottom );
void grabKeyboard (void *object);
void grabMouse (void *object);
void grabMouse_2 (void *object, const QCursor & cursor );
int grabShortcut (void *object, const QKeySequence & key, Qt::ShortcutContext context = Qt::WindowShortcut );
QGraphicsEffect * graphicsEffect (void *object);
QGraphicsProxyWidget * graphicsProxyWidget (void *object);
int hasEditFocus (void *object);
int hasFocus (void *object);
int hasMouseTracking (void *object);
int height (void *object);
int heightForWidth (void *object, int w );
QInputContext * inputContext (void *object);
Qt::InputMethodHints inputMethodHints (void *object);
QVariant inputMethodQuery (void *object, Qt::InputMethodQuery query );
void insertAction (void *object, QAction * before, QAction * action );
void insertActions (void *object, QAction * before, QList<QAction *> actions );
int isActiveWindow (void *object);
int isAncestorOf (void *object, const void * child );
int isEnabled (void *object);
int isEnabledTo (void *object, void * ancestor );
int isFullScreen (void *object);
int isHidden (void *object);
int isMaximized (void *object);
int isMinimized (void *object);
int isModal (void *object);
int isVisible (void *object);
int isVisibleTo (void *object, void * ancestor );
int isWindow (void *object);
int isWindowModified (void *object);
QLayout * layout (void *object);
Qt::LayoutDirection layoutDirection (void *object);
QLocale locale (void *object);
Qt::HANDLE macCGHandle (void *object);
Qt::HANDLE macQDHandle (void *object);
QPoint mapFrom (void *object, void * parent, const QPoint & pos );
QPoint mapFromGlobal (void *object, const QPoint & pos );
QPoint mapFromParent (void *object, const QPoint & pos );
QPoint mapTo (void *object, void * parent, const QPoint & pos );
QPoint mapToGlobal (void *object, const QPoint & pos );
QPoint mapToParent (void *object, const QPoint & pos );
QRegion mask (void *object);
int maximumHeight (void *object);
QSize maximumSize (void *object);
int maximumWidth (void *object);
int minimumHeight (void *object);
QSize minimumSize (void *object);
QSize minimumSizeHint (void *object);
int minimumWidth (void *object);
void move (void *object, const QPoint & );
void move_2 (void *object, int x, int y );
void * nativeParentWidget (void *object);
void * nextInFocusChain (void *object);
QRect normalGeometry (void *object);
void * parentWidget (void *object);
QPoint pos (void *object);
void * previousInFocusChain (void *object);
QRect rect (void *object);
void releaseKeyboard (void *object);
void releaseMouse (void *object);
void releaseShortcut (void *object, int id );
void removeAction ( QAction * action );
void repaint (void *object, int x, int y, int w, int h );
void repaint_2 (void *object, const QRect & rect );
void repaint_3 (void *object, const QRegion & rgn );
void resize (void *object, const QSize & );
void resize_2 (void *object, int w, int h );
int restoreGeometry (void *object, const QByteArray & geometry );
QByteArray saveGeometry (void *object);
void scroll (void *object, int dx, int dy );
void scroll_2 (void *object, int dx, int dy, const QRect & r );
void setAcceptDrops (void *object, int on );
void setAccessibleDescription (void *object, const QString & description );
void setAccessibleName (void *object, const QString & name );
void setAttribute (void *object, Qt::WidgetAttribute attribute, int on = true );
void setAutoFillBackground (void *object, int enabled );
void setBackgroundRole (void *object, QPalette::ColorRole role );
void setBaseSize (void *object, const QSize & );
void setBaseSize_2 (void *object, int basew, int baseh );
void setContentsMargins (void *object, int left, int top, int right, int bottom );
void setContentsMargins_2 (void *object, const QMargins & margins );
void setContextMenuPolicy (void *object, Qt::ContextMenuPolicy policy );
void setCursor (void *object, const QCursor & );
void setEditFocus (void *object, int enable );
void setFixedHeight (void *object, int h );
void setFixedSize (void *object, const QSize & s );
void setFixedSize_2 (void *object, int w, int h );
void setFixedWidth (void *object, int w );
void setFocus (void *object, Qt::FocusReason reason );
void setFocusPolicy (void *object, Qt::FocusPolicy policy );
void setFocusProxy (void *object, void * w );
void setFont (void *object, const QFont & );
void setForegroundRole (void *object, QPalette::ColorRole role );
void setGeometry (void *object, const QRect & );
void setGeometry_2 (void *object, int x, int y, int w, int h );
void setGraphicsEffect (void *object, QGraphicsEffect * effect );
void setInputContext (void *object, QInputContext * context );
void setInputMethodHints (void *object, Qt::InputMethodHints hints );
void setLayout (void *object, QLayout * layout );
void setLayoutDirection (void *object, Qt::LayoutDirection direction );
void setLocale (void *object, const QLocale & locale );
void setMask (void *object, const QBitmap & bitmap );
void setMask_2 (void *object, const QRegion & region );
void setMaximumHeight (void *object, int maxh );
void setMaximumSize (void *object, const QSize & );
void setMaximumSize_2 (void *object, int maxw, int maxh );
void setMaximumWidth (void *object, int maxw );
void setMinimumHeight (void *object, int minh );
void setMinimumSize (void *object, const QSize & );
void setMinimumSize_2 (void *object, int minw, int minh );
void setMinimumWidth (void *object, int minw );
void setMouseTracking (void *object, int enable );
void setPalette (void *object, const QPalette & );
void setParent (void *object, void * parent );
void setParent_2 (void *object, void * parent, Qt::WindowFlags f );
void setShortcutAutoRepeat (void *object, int id, int enable = true );
void setShortcutEnabled (void *object, int id, int enable = true );
void setSizeIncrement (void *object, const QSize & );
void setSizeIncrement_2 (void *object, int w, int h );
void setSizePolicy (void *object, QSizePolicy );
void setSizePolicy_2 (void *object, QSizePolicy::Policy horizontal, QSizePolicy::Policy vertical );
void setStatusTip (void *object, const QString & );
void setStyle (void *object, QStyle * style );
void setToolTip (void *object, const QString & );
void setUpdatesEnabled (void *object, int enable );
void setWhatsThis (void *object, const QString & );
void setWindowFilePath (void *object, const QString & filePath );
void setWindowFlags (void *object, Qt::WindowFlags type );
void setWindowIcon (void *object, const QIcon & icon );
void setWindowIconText (void *object, const QString & );
void setWindowModality (void *object, Qt::WindowModality windowModality );
void setWindowOpacity (void *object, qreal level );
void setWindowRole (void *object, const QString & role );
void setWindowState (void *object, Qt::WindowStates windowState );
void setupUi (void *object, void * widget );
QSize size (void *object);
QSize sizeHint (void *object);
QSize sizeIncrement (void *object);
QSizePolicy sizePolicy (void *object);
void stackUnder (void *object, void * w );
int QWidget_statusTip (void *object)
{
    QString s = ((QWidget*)object)->statusTip();
    int i;

    memcpy(&i,&s,4);
    return i;
}

QStyle * style (void *object);
int QWidget_styleSheet (void *object)
{
    QString s = ((QWidget*)object)->styleSheet();
    int i;

    memcpy(&i,&s,4);
    return i;
}

int QWidget_testAttribute (void *object, Qt::WidgetAttribute attribute );
int toolTip (void *object)
{
    QString s = ((QWidget*)object)->toolTip();
    int i;

    memcpy(&i,&s,4);
    return i;
}

int underMouse (void *object);
void ungrabGesture (void *object, Qt::GestureType gesture );
void unsetCursor (void *object);
void unsetLayoutDirection (void *object);
void unsetLocale (void *object);
void update (void *object, int x, int y, int w, int h );
void update_2 (void *object, const QRect & rect );
void update_3 (void *object, const QRegion & rgn );
void updateGeometry (void *object);
int updatesEnabled (void *object);
QRegion visibleRegion (void *object);
int QWidget_whatsThis (void *object)
{
    QString s = ((QWidget*)object)->whatsThis();
    int i;

    memcpy(&i,&s,4);
    return i;
}

int width (void *object);
WId winId (void *object);
void * window (void *object);
int QWidget_windowFilePath (void *object)
{
    QString s = ((QWidget*)object)->windowFilePath();
    int i;

    memcpy(&i,&s,4);
    return i;
}

Qt::WindowFlags windowFlags (void *object);
QIcon windowIcon (void *object);
int QWidget_windowIconText (void *object)
{
    QString s = ((QWidget*)object)->windowIconText();
    int i;

    memcpy(&i,&s,4);
    return i;
}

Qt::WindowModality windowModality (void *object);
qreal windowOpacity (void *object);
__declspec( dllexport ) int QWidget_windowRole (void *object)
{
    QString s = ((QWidget*)object)->windowRole();
    int i;

    memcpy(&i,&s,4);
    return i;
}

Qt::WindowStates windowState (void *object);
__declspec( dllexport ) void QWidget_windowTitle (void *object, char *s)
{
    strcpy(s,((QWidget*)object)->windowTitle().toAscii());
}

Qt::WindowType windowType (void *object);
int x (void *object);
const QX11Info & x11Info (void *object);
Qt::HANDLE x11PictureHandle (void *object);
int y (void *object);





}
